{ ᪮ ࠭  ਭ}
Type
 TPalette = set of byte;
Const
 Port = 0; {FIXME: } {ᯮ㥬 LPT1}
 {BIOS printer commands}
 CM_PRINT = 0;
 CM_INITPRINTER = 1;
 CM_GETPRINTERINFO = 2;
 {Printer types}
 NONE = 0;
 MATRIX8 = 1;
 MATRIX24 = 2;

Uses Graph; { 㤥  ᥫ  ࠭, ᯮ
 ⠭ 楤 Pascal'  ᮢ⨬  ᥬ ०}

function _biosprint(cmd, _byte : byte; port : integer) : byte;
Var Answer : byte;
begin
 asm
  mov   ah,cmd
  mov   al,_byte
  mov   dx,port
  int   17h
  mov   Answer,ah
 end;
 _biosprint := Answer
end;

function _print(_byte : byte) : byte;
begin
  _print := _biosprint(CM_PRINT,_byte,port)
end;
{
>p楤p ⠥ ᮪ p, p塞 x1,y1,x2,y2  8-pin
>pp, p ⮬  ⮫쪮 梥, p   ⢥
>palette}
Procedure PrintScreenFX(x1,y1,x2,y2:integer; palette : TPalette);
Var
 numpasses : integer;
 numcols : integer;
 _byte : integer;
 pass : integer;
 x,y,i : integer;
begin
 numpasses := (y2 shr 3) - (y1 shr 3) +1;
 numcols := x2 - x1 +1;
 _Print(13); {FIXME: No error checking.}
 y := y1;
 for pass := 0 to NumPasses-1 Do
  begin
   _Print(27);
   _Print(76);
   _Print(NumCols and $FF);
   _Print(NumCols shr 8);
   for x := x1 to x2 do
    begin
     _byte := 0;
     for i := 0 to 7 do
      if (y+i<=y2) then
       if (getpixel(x,y+i) in palette) Then _byte := _byte or ($80 shr i);
     _Print(_byte)
    end;
   _Print(27);
   _Print(74);
   _Print(24);
   _Print(13);
   y := y+8
  end
end;
{
> , ⮫쪮  24-pin pp}
Procedure PrintScreenLQ(x1,y1,x2,y2:integer; Palette : TPalette);
Var
 numpasses : integer;
 numcols : integer;
 byte1,byte2,byte3 : integer;
 pass : integer;
 x,y,i : integer;
begin
 numpasses := (y2 - y1) div 24 + 1;
 numcols := x2 - x1 + 1;
 _Print(13); {FIXME: No error checking.}
 y := y1;
 for pass := 0 to NumPasses-1 Do
  begin
   _Print(27);{ESC * 33 n1 n2}
   _Print(42);
   _Print(33);
   _Print(NumCols and $FF);
   _Print(NumCols shr 8);
   for x := x1 to x2 do
    begin
     byte1 := 0;
     byte2 := 0;
     byte3 := 0;
     for i := 0 to 7 do
      if (y+i<=y2) then
       if (getpixel(x,y+i) in palette) Then byte1 := byte1 or ($80 shr i);
     for i := 0 to 7 do
      if (y+8+i<=y2) then
       if (getpixel(x,y+8+i) in palette) Then byte2 := byte2 or ($80 shr i);
     for i := 0 to 7 do
      if (y+16+i<=y2) then
       if (getpixel(x,y+16+i) in palette) Then byte3 := byte3 or ($80 shr i);
     _Print(byte1);
     _Print(byte2);
     _Print(byte3)
    end;
   _Print(27);
   _Print(74);
   _Print(24);
   _Print(13);
   y := y+24
  end
end;

